
//  The VNC system is free software; you can redistribute it and/or modify
//  it under the terms of the GNU General Public License as published by
//  the Free Software Foundation; either version 2 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
//  USA.
//
// If the source code for the VNC system is not available from the place 
// whence you received this file, check http://www.orl.co.uk/vnc or contact
// the authors on vnc@orl.co.uk for information on obtaining it.


#ifndef VNCIPAUTH
#define VNCIPAUTH

#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include "stdhdrs.h"


// Number of numbers in an IP (V4 for now) number
static const int	IP_LENGTH = 4;
static const char	ALLOW[] =	"ALLOW";
static const char	DENY[]	=	"DENY";
static const char	ALL[]	=	"ALL";
static const int	INVALID_NUM = -1;

// This is the name of the datafile which we will use
static const char IP_FILENAME[]	= "iplist.txt";


// A linked list element which stores a char [] of an
// allowed or disallowed IP
class vncll_IP  {

// Public Member functions
public:
	
	// Constructor
	vncll_IP(int ip[IP_LENGTH]);
	~vncll_IP(void);

	int		IsMatch(const int IPToCheck[IP_LENGTH]);

// Public data
public:
	vncll_IP*	next;

// Private member data
private:
	int		IP[IP_LENGTH];
};


class vncIPAuth {

public:
//	vncIPAuth(void);  // deprecated
	vncIPAuth(char *AllowList, char *DenyList, long DenyAll);
	~vncIPAuth(void);
	int		IsAuthorizedIP(const char * IPToCheck);

// Private member functions
private:
//	void	ReadIPListFile(void);  // deprecated
	void	ProcessRegistryKeys(char *AllowList, char *DenyList,
								long DenyAllIPs);
	void	ProcessIP(const char* RawIP, int IP[]);

private:
	// Linked list of allowed ip masks
	vncll_IP*	Allowed;
	vncll_IP*	AllowedTail;
	// Linked list of denied ip masks
	vncll_IP*	Denied;
	vncll_IP*	DeniedTail;

	// a separate flag for denying all hosts
	bool		DenyAll;
	
};

#endif // VNCIPAUTH